freeslot("SKINCOLOR_AFTERIMAGERED","SKINCOLOR_AFTERIMAGEGREEN")

skincolors[SKINCOLOR_AFTERIMAGERED] = {
    name = "After Image Red",
    ramp = {35,35,35,35,35,35,35,35,35,35,35,41,41,41,41,41},
    invcolor = SKINCOLOR_RED,
    invshade = 9,
    chatcolor = V_REDMAP,
    accessible = true
}

skincolors[SKINCOLOR_AFTERIMAGEGREEN] = {
    name = "After Image Green",
    ramp = {100,100,100,100,100,100,100,100,100,100,100,191,191,191,191,191},
    invcolor = SKINCOLOR_GREEN,
    invshade = 9,
    chatcolor = V_GREENMAP,
    accessible = true
}

local function createafterimage(p)
	if leveltime%5 == 0
		local afti = P_SpawnGhostMobj(p.mo)
		afti.colorized = true
		afti.fuse = 999
		afti.tics = 5
		afti.color = P_RandomRange(SKINCOLOR_AFTERIMAGERED,SKINCOLOR_AFTERIMAGEGREEN)
		afti.frame = TR_TRANS10|p.mo.frame|FF_FULLBRIGHT
		afti.scale = p.mo.scale
	end
end

local function dashmodeshit(p)
	if leveltime%10 == 0
	and p.normalspeed < 120*FRACUNIT
		p.normalspeed = $+FRACUNIT
	end
end

local function dust(p)
	if P_IsObjectOnGround(p.mo)
		P_SpawnSkidDust(p, 17*FU)
	end
end

local skin = "sonki"

addHook("PlayerThink", function(p)
	if p.sonkidesh == nil
		p.sonkidesh = 0
	end
	local topsped = skins[p.mo.skin].normalspeed - 5*FRACUNIT
	if p.mo.skin == SONKI_SKIN
	and p.mo and p.mo.valid
	and p.playerstate == PST_LIVE
	and (p.speed >= topsped or p.pflags & PF_STARTDASH)
		p.sonkidesh = $1+1
	end
	if p.sonkidesh == 2*TICRATE --if you just reached boost mode play a sound
		S_StartSound(p.mo, sfx_kc4d)
	end
	if p.sonkidesh >= 2*TICRATE --shit to do when in dashmode
		dashmodeshit(p)
		dust(p)
		createafterimage(p)
		p.charflags = ($|SF_RUNONWATER|SF_CANBUSTWALLS)
	end
	if p.mo.state == S_PLAY_DASH
	and p.mo.skin == SONKI_SKIN
	and p.sonkidesh < 3*TICRATE
		p.mo.state = S_PLAY_RUN
	end
	if p.sonkidesh >= 2*TICRATE
	and p.speed < p.runspeed
	and P_IsObjectOnGround(p.mo)
	and not (p.pflags & PF_SPINNING)	
		p.sonkidesh = 0
		S_StartSound(p.mo,sfx_kc65)
		p.normalspeed = skins[p.mo.skin].normalspeed
		p.charflags = ($ & ~SF_RUNONWATER|SF_CANBUSTWALLS)
	end
	if p.sonkidesh < 2*TICRATE
	and p.speed < p.runspeed
	and P_IsObjectOnGround(p.mo)
	and not (p.pflags & PF_SPINNING)
	or p.sonkidesh > 3*TICRATE
	and p.playerstate == PST_DEAD
		p.sonkidesh = 0
		p.normalspeed = skins[p.mo.skin].normalspeed
		p.charflags = ($ & ~SF_RUNONWATER|SF_CANBUSTWALLS)
	end
	if p.speed >= 70*FRACUNIT and not (p.sonkidesh >= 3*TICRATE)
		S_StartSound(p.mo, sfx_kc4d)
		p.sonkidesh = 4*TICRATE
	end
end)